#!/usr/bin/python
# -*- encoding: utf-8; py-indent-offset: 4 -*-
#
# License: GNU General Public License v2
#
# Author: thl-cmk[at]outlook[dot]com
# URL   : https://thl-cmk.hopto.org
# Date  : 2018-03-17
#
# Check Point Firewall connections metrics plugins
# checkpoint_fw_connections
#

##############################################################################
#
# define units for perfdata
#
##############################################################################

##############################################################################
#
# define metrics for perfdata
#
##############################################################################

metric_info['checkpoint_fw_connections_fwconnectionstcp'] = {
    'title': _('TCP connections'),
    'unit': '1/s',
    'color': '11/a',
}
metric_info['checkpoint_fw_connections_fwconnectionsudp'] = {
    'title': _('UDP connections'),
    'unit': '1/s',
    'color': '12/a',
}
metric_info['checkpoint_fw_connections_fwconnectionsicmp'] = {
    'title': _('ICMP connections'),
    'unit': '1/s',
    'color': '13/a',
}
metric_info['checkpoint_fw_connections_fwconnectionsother'] = {
    'title': _('Other connections'),
    'unit': '1/s',
    'color': '14/a',
}
metric_info['checkpoint_fw_connections_fwconnectionssum'] = {
    'title': _('Total connections'),
    'unit': '1/s',
    'color': '15/a',
}
metric_info['checkpoint_fw_connections_fwconnectionrate'] = {
    'title': _('Connections rate'),
    'unit': '1/s',
    'color': '22/a',
}

metric_info['checkpoint_fw_connections_fwcurrentnumconn'] = {
    'title': _('Current connections'),
    'unit': 'count',
    'color': '26/a',
}
metric_info['checkpoint_fw_connections_fwpeaknumconn'] = {
    'title': _('Peak Connections'),
    'unit': 'count',
    'color': '16/a',
}


##############################################################################
#
# map perfdata to metric
#
##############################################################################


check_metrics['check_mk-checkpoint_fw_connections'] = {
    'fwconnectionstcp': {'name': 'checkpoint_fw_connections_fwconnectionstcp', },
    'fwconnectionsudp': {'name': 'checkpoint_fw_connections_fwconnectionsudp', },
    'fwconnectionsicmp': {'name': 'checkpoint_fw_connections_fwconnectionsicmp', },
    'fwconnectionsother': {'name': 'checkpoint_fw_connections_fwconnectionsother', },
    'fwconnectionssum': {'name': 'checkpoint_fw_connections_fwconnectionssum', },
    'fwconnectionrate': {'name': 'checkpoint_fw_connections_fwconnectionrate', },
    'fwcurrentnumconn': {'name': 'checkpoint_fw_connections_fwcurrentnumconn', },
    'fwpeaknumconn': {'name': 'checkpoint_fw_connections_fwpeaknumconn', },
}

##############################################################################
#
# how to graph perdata
#
##############################################################################

graph_info.append({
    'title': _('Check Point Firewall Connections per second'),
    'metrics': [
        ('checkpoint_fw_connections_fwconnectionstcp', 'stack'),
        ('checkpoint_fw_connections_fwconnectionsudp', 'stack'),
        ('checkpoint_fw_connections_fwconnectionsicmp', 'stack'),
        ('checkpoint_fw_connections_fwconnectionsother', 'stack'),
        ('checkpoint_fw_connections_fwconnectionssum', 'line'),
        ('checkpoint_fw_connections_fwconnectionrate', 'line'),
    ],
})

graph_info.append({
    'title': _('Check Point Firewall Connections count'),
    'metrics': [
        ('checkpoint_fw_connections_fwpeaknumconn', 'line'),
        ('checkpoint_fw_connections_fwcurrentnumconn', 'area'),
    ],
    'scalars': [
        ('checkpoint_fw_connections_fwcurrentnumconn:crit', _('crit')),
        ('checkpoint_fw_connections_fwcurrentnumconn:warn', _('warn')),
    ],
})


##############################################################################
#
# define perf-o-meter
#
##############################################################################


perfometer_info.append(('stacked', [
    {
        'type': 'logarithmic',
        'metric': 'checkpoint_fw_connections_fwcurrentnumconn',
        'half_value': 100000.0,
        'exponent': 2,
    },
    {
        'type': 'logarithmic',
        'metric': 'checkpoint_fw_connections_fwconnectionrate',
        'half_value': 1000.0,
        'exponent': 2,
    },
]))