#!/usr/bin/python
# -*- encoding: utf-8; py-indent-offset: 4 -*-
#
# License: GNU General Public License v2
#
# Author: thl-cmk[at]outlook[dot]com
# URL   : https://thl-cmk.hopto.org
# Date  : 2020-06-07
#
register_check_parameters(
    subgroup_applications,
    'checkpoint_fw_connections',
    _('Check Point Firewall Connections'),
    Dictionary(
        elements=[
            ('warncritcurrent',
             Tuple(
                 title=_('Levels for number of current active connections'),
                 elements=[
                     Integer(title=_('Warning at'), default_value=1000, unit=_('Count'), allow_empty=False),
                     Integer(title=_('Critical at'), default_value=2000, unit=_('Count'), allow_empty=False),
                 ])),
            ('warncritrate',
             Tuple(
                 title=_('Levels for number of new connections/s'),
                 elements=[
                     Integer(title=_('Warning at'), default_value=100, unit=_('Count'), allow_empty=False),
                     Integer(title=_('Critical at'), default_value=200, unit=_('Count'), allow_empty=False),
                 ])),
        ],
    ),
    None,
    match_type='dict',
)